Package org.jboss.resteasy.plugins.server

## Class BaseHttpRequest

- java.lang.Object
- - org.jboss.resteasy.plugins.server.BaseHttpRequest

- All Implemented Interfaces:
    `HttpRequest`
  Direct Known Subclasses:
    `HttpServerRequest`, `HttpServletInputMessage`, `MockHttpRequest`, `NettyHttpRequest`, `VertxHttpRequest`

      public abstract class BaseHttpRequest
      extends Object
      implements HttpRequest

  Helper for creating HttpRequest implementations. The async code is a fake implementation to work with http engines that don't support async HTTP.
  Version:
    $Revision: 1 $
  Author:
    Bill Burke

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected javax.ws.rs.core.MultivaluedMap<String,​String>` | `decodedFormParameters` |
    `protected javax.ws.rs.core.MultivaluedMap<String,​String>` | `formParameters` |
    `protected ResteasyUriInfo` | `uri` |

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `BaseHttpRequest​(ResteasyUriInfo uri)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `formParametersRead()` | Were form parameters read before marshalling to body?
    `javax.ws.rs.core.MultivaluedMap<String,​String>` | `getDecodedFormParameters()` |
    `javax.ws.rs.core.MultivaluedMap<String,​String>` | `getFormParameters()` | application/x-www-form-urlencoded parameters
    `ResteasyUriInfo` | `getUri()` | This method *MUST* always return the same instance.
    `boolean` | `isInitial()` |
    `void` | `setRequestUri​(URI requestUri)` | Updates the object returned by `HttpRequest.getUri()`.
    `void` | `setRequestUri​(URI baseUri, URI requestUri)` | Updates the object returned by `HttpRequest.getUri()`.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.jboss.resteasy.spi.HttpRequest

      `forward, getAsyncContext, getAttribute, getAttributeNames, getHttpHeaders, getHttpMethod, getInputStream, getMutableHeaders, getRemoteAddress, getRemoteHost, removeAttribute, setAttribute, setHttpMethod, setInputStream, wasForwarded`

- - ### Field Detail

    - #### formParameters

          protected javax.ws.rs.core.MultivaluedMap<String,​String> formParameters

    - #### decodedFormParameters

          protected javax.ws.rs.core.MultivaluedMap<String,​String> decodedFormParameters

    - #### uri

          protected ResteasyUriInfo uri

  - ### Constructor Detail

    - #### BaseHttpRequest

          protected BaseHttpRequest​(ResteasyUriInfo uri)

  - ### Method Detail

    - #### getUri

          public ResteasyUriInfo getUri()

      Description copied from interface: `HttpRequest`
      This method *MUST* always return the same instance.
      Specified by:
        `getUri` in interface `HttpRequest`
      Returns:
        uri info

    - #### formParametersRead

          public boolean formParametersRead()

      Description copied from interface: `HttpRequest`
      Were form parameters read before marshalling to body?
      Specified by:
        `formParametersRead` in interface `HttpRequest`
      Returns:

    - #### getFormParameters

          public javax.ws.rs.core.MultivaluedMap<String,​String> getFormParameters()

      Description copied from interface: `HttpRequest`
      application/x-www-form-urlencoded parameters

      This is here because @FormParam needs it and for when there are servlet filters that eat up the input stream

      Specified by:
        `getFormParameters` in interface `HttpRequest`
      Returns:
        null if no parameters, this is encoded map

    - #### getDecodedFormParameters

          public javax.ws.rs.core.MultivaluedMap<String,​String> getDecodedFormParameters()

      Specified by:
        `getDecodedFormParameters` in interface `HttpRequest`

    - #### isInitial

          public boolean isInitial()

      Specified by:
        `isInitial` in interface `HttpRequest`

    - #### setRequestUri

          public void setRequestUri​(URI requestUri)
                             throws IllegalStateException

      Description copied from interface: `HttpRequest`
      Updates the object returned by `HttpRequest.getUri()`.
      Specified by:
        `setRequestUri` in interface `HttpRequest`
      Parameters:
        `requestUri` - request uri
      Throws:
        `IllegalStateException`

    - #### setRequestUri

          public void setRequestUri​(URI baseUri,
                                    URI requestUri)
                             throws IllegalStateException

      Description copied from interface: `HttpRequest`
      Updates the object returned by `HttpRequest.getUri()`.
      Specified by:
        `setRequestUri` in interface `HttpRequest`
      Parameters:
        `baseUri` - base uri
        `requestUri` - request uri
      Throws:
        `IllegalStateException`